/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxConfirmation struct for TxConfirmation
type TxConfirmation struct {
	// Current Block Number
	CurrentHeight *int64 `json:"current_height,omitempty"`
	// Transaction hash
	TxId *string `json:"tx_id,omitempty"`
	// Total transaction confirmations
	Confirmations *int64 `json:"confirmations,omitempty"`
}

// NewTxConfirmation instantiates a new TxConfirmation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxConfirmation() *TxConfirmation {
	this := TxConfirmation{}
	return &this
}

// NewTxConfirmationWithDefaults instantiates a new TxConfirmation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxConfirmationWithDefaults() *TxConfirmation {
	this := TxConfirmation{}
	return &this
}

// GetCurrentHeight returns the CurrentHeight field value if set, zero value otherwise.
func (o *TxConfirmation) GetCurrentHeight() int64 {
	if o == nil || o.CurrentHeight == nil {
		var ret int64
		return ret
	}
	return *o.CurrentHeight
}

// GetCurrentHeightOk returns a tuple with the CurrentHeight field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxConfirmation) GetCurrentHeightOk() (*int64, bool) {
	if o == nil || o.CurrentHeight == nil {
		return nil, false
	}
	return o.CurrentHeight, true
}

// HasCurrentHeight returns a boolean if a field has been set.
func (o *TxConfirmation) HasCurrentHeight() bool {
	if o != nil && o.CurrentHeight != nil {
		return true
	}

	return false
}

// SetCurrentHeight gets a reference to the given int64 and assigns it to the CurrentHeight field.
func (o *TxConfirmation) SetCurrentHeight(v int64) {
	o.CurrentHeight = &v
}

// GetTxId returns the TxId field value if set, zero value otherwise.
func (o *TxConfirmation) GetTxId() string {
	if o == nil || o.TxId == nil {
		var ret string
		return ret
	}
	return *o.TxId
}

// GetTxIdOk returns a tuple with the TxId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxConfirmation) GetTxIdOk() (*string, bool) {
	if o == nil || o.TxId == nil {
		return nil, false
	}
	return o.TxId, true
}

// HasTxId returns a boolean if a field has been set.
func (o *TxConfirmation) HasTxId() bool {
	if o != nil && o.TxId != nil {
		return true
	}

	return false
}

// SetTxId gets a reference to the given string and assigns it to the TxId field.
func (o *TxConfirmation) SetTxId(v string) {
	o.TxId = &v
}

// GetConfirmations returns the Confirmations field value if set, zero value otherwise.
func (o *TxConfirmation) GetConfirmations() int64 {
	if o == nil || o.Confirmations == nil {
		var ret int64
		return ret
	}
	return *o.Confirmations
}

// GetConfirmationsOk returns a tuple with the Confirmations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxConfirmation) GetConfirmationsOk() (*int64, bool) {
	if o == nil || o.Confirmations == nil {
		return nil, false
	}
	return o.Confirmations, true
}

// HasConfirmations returns a boolean if a field has been set.
func (o *TxConfirmation) HasConfirmations() bool {
	if o != nil && o.Confirmations != nil {
		return true
	}

	return false
}

// SetConfirmations gets a reference to the given int64 and assigns it to the Confirmations field.
func (o *TxConfirmation) SetConfirmations(v int64) {
	o.Confirmations = &v
}

func (o TxConfirmation) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.CurrentHeight != nil {
		toSerialize["current_height"] = o.CurrentHeight
	}
	if o.TxId != nil {
		toSerialize["tx_id"] = o.TxId
	}
	if o.Confirmations != nil {
		toSerialize["confirmations"] = o.Confirmations
	}
	return json.Marshal(toSerialize)
}

type NullableTxConfirmation struct {
	value *TxConfirmation
	isSet bool
}

func (v NullableTxConfirmation) Get() *TxConfirmation {
	return v.value
}

func (v *NullableTxConfirmation) Set(val *TxConfirmation) {
	v.value = val
	v.isSet = true
}

func (v NullableTxConfirmation) IsSet() bool {
	return v.isSet
}

func (v *NullableTxConfirmation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxConfirmation(val *TxConfirmation) *NullableTxConfirmation {
	return &NullableTxConfirmation{value: val, isSet: true}
}

func (v NullableTxConfirmation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxConfirmation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
